import 'package:osam/domain/event/event.dart';
import 'package:osam/domain/state/base_state.dart';
import 'package:osam/domain/store/store.dart';

typedef bool Condition(Event event);

abstract class Middleware<S extends Store<BaseState>> {
  S store;

  bool nextEvent(bool next) => next;
  List<Condition> get conditions;

  @override
  bool operator ==(Object other) => runtimeType == other.runtimeType;

  @override
  int get hashCode => runtimeType.hashCode;
}
