import 'package:flutter/material.dart';
import 'package:osam/domain/state/base_state.dart';

typedef Widget Builder<T>(BuildContext context, AsyncSnapshot<T> snapshot);

class OsamBuilder<T> extends StatelessWidget {
  final StateStream<T> stream;
  final Builder<T> builder;

  const OsamBuilder({Key key, this.stream, this.builder}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return StreamBuilder(
      key: ValueKey(key.toString() + 'stB'),
      stream: stream.stream,
      initialData: stream.initialData,
      builder: (ctx, AsyncSnapshot<T> snapshot) => builder(ctx, snapshot),
    );
  }
}
